
#ifndef	_ICPDAS_CANHS_H
#define	_ICPDAS_CANHS_H

#ifdef ICPDAS_CANHS_EXPORTS
	#define _EXP_ICPDAS_CANHS __declspec(dllexport)
#else
	#define _EXP_ICPDAS_CANHS __declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C" {
#endif


//#Error Code
#define DEV_RETURN_ERR_CODE_BASE  0				//Device
#define DEVLIB_ERR_CODE_BASE      0x10000		//USB Device Library
#define CANHSLIB_ERR_CODE_BASE    0x10100		//CANHS Library

#define ERR_NO_ERR                0
/* CANHS Library Error Codes */
#define ERR_CANHS_COMM_TIMEOUT      (CANHSLIB_ERR_CODE_BASE + 0)
#define ERR_CANHS_INVALID_Port      (CANHSLIB_ERR_CODE_BASE + 1)
#define ERR_CANHS_CANRxNoData	    (CANHSLIB_ERR_CODE_BASE + 2)
#define ERR_CANHS_CANTxBufOverflow  (CANHSLIB_ERR_CODE_BASE + 3)
#define ERR_CANHS_WriteListCIDNumErr	(CANHSLIB_ERR_CODE_BASE + 4)

//Device Reture Error code
#define	ERR_DEV_OPError				(DEV_RETURN_ERR_CODE_BASE + 1)
#define	ERR_DEV_FCError				(DEV_RETURN_ERR_CODE_BASE + 2)
#define	ERR_DEV_DLError				(DEV_RETURN_ERR_CODE_BASE + 3)
#define	ERR_DEV_WriteDataError		(DEV_RETURN_ERR_CODE_BASE + 4)


// SYSTEM
_EXP_ICPDAS_CANHS int __stdcall CANHS_ScanDevice(void);
_EXP_ICPDAS_CANHS BYTE __stdcall CANHS_ListDevice(WORD* o_wPID, DWORD* o_dwBID);
_EXP_ICPDAS_CANHS int __stdcall CANHS_OpenDevice(WORD *o_wDevice_id, WORD i_wpid, DWORD i_wbid);
_EXP_ICPDAS_CANHS int __stdcall CANHS_CloseDevice(WORD i_wDevice_id);

// DEVICE
//GET API
_EXP_ICPDAS_CANHS int __stdcall CANHS_GetFwVer(WORD i_wDevice_id, WORD* o_wFwVer);
_EXP_ICPDAS_CANHS int __stdcall CANHS_GetModuleStatus(WORD i_wDevice_id, DWORD* o_dwStatus);
_EXP_ICPDAS_CANHS int __stdcall CANHS_GetINITPinStatus(WORD i_wDevice_id, BYTE* o_bStatus);

_EXP_ICPDAS_CANHS int __stdcall CANHS_GetCANOPMode(WORD i_wDevice_id, BYTE i_byCANPort, WORD* o_wEnable, WORD* o_wMode);
_EXP_ICPDAS_CANHS int __stdcall CANHS_GetCANStatus(WORD i_wDevice_id, BYTE i_byCANPort, DWORD* o_dwCANStatus, DWORD* o_dwErrCnt, DWORD* o_dwBufStatus);
_EXP_ICPDAS_CANHS int __stdcall CANHS_GetCANBaudSPEEP(WORD i_wDevice_id, BYTE i_byCANPort, DWORD* o_dwBaud, DWORD* o_dwSP);
_EXP_ICPDAS_CANHS int __stdcall CANHS_GetCANBaudSP(WORD i_wDevice_id, BYTE i_byCANPort, DWORD* o_dwBaud, DWORD* o_dwSP);
_EXP_ICPDAS_CANHS int __stdcall CANHS_GetCANFilter(WORD i_wDevice_id, BYTE i_byCANPort, BYTE *o_byMode, DWORD* o_dwMask, DWORD* o_dwArbitration);
_EXP_ICPDAS_CANHS int __stdcall CANHS_GetCANHWSendMode(WORD i_wDevice_id, BYTE i_byCANPort, BYTE *o_byMode);
_EXP_ICPDAS_CANHS int __stdcall CANHS_GetCANWhiteListMode(WORD i_wDevice_id, BYTE i_byCANPort, BYTE *o_byMode);
_EXP_ICPDAS_CANHS int __stdcall CANHS_GetCANBlackListMode(WORD i_wDevice_id, BYTE i_byCANPort, BYTE *o_byMode);
_EXP_ICPDAS_CANHS int __stdcall CANHS_GetCANWhiteListCANID(WORD i_wDevice_id, BYTE i_byCANPort, WORD *o_wCIDNum, DWORD *o_dwCID);
_EXP_ICPDAS_CANHS int __stdcall CANHS_GetCANBlackListCANID(WORD i_wDevice_id, BYTE i_byCANPort, WORD *o_wCIDNum, DWORD *o_dwCID);
_EXP_ICPDAS_CANHS int __stdcall CANHS_GetCANRxFramePerSec(WORD i_wDevice_id, BYTE i_byCANPort, WORD *o_wRxFPS);

_EXP_ICPDAS_CANHS int __stdcall CANHS_GetCANRxMsgCount(WORD i_wDevice_id, BYTE i_byCANPort, DWORD* o_dwCount);
_EXP_ICPDAS_CANHS int __stdcall CANHS_GetCANRxMsg(WORD i_wDevice_id, BYTE i_byCANPort, BYTE* o_byType, BYTE* o_byMode, DWORD* o_dwID, BYTE* o_byRTR, BYTE* o_byDlen, BYTE *o_byData, DWORD *o_dw_TimeStamp_s, DWORD *o_dw_TimeStamp_us);

//SET API
_EXP_ICPDAS_CANHS int __stdcall CANHS_SetLED(WORD i_wDevice_id, BYTE i_byLED);
_EXP_ICPDAS_CANHS int __stdcall CANHS_SetSN(WORD i_wDevice_id, DWORD i_dwSN);
_EXP_ICPDAS_CANHS int __stdcall CANHS_SetQCLedFlag(WORD i_wDevice_id, BYTE i_byQCLEDFlag);

_EXP_ICPDAS_CANHS int __stdcall CANHS_SetCANOPMode(WORD i_wDevice_id, BYTE i_byCANPort, WORD i_wEnable, WORD i_wMode);
_EXP_ICPDAS_CANHS int __stdcall CANHS_SetCANBaudSP(WORD i_wDevice_id, BYTE i_byCANPort, DWORD i_dwBR, DWORD i_dwSP);
_EXP_ICPDAS_CANHS int __stdcall CANHS_SetCANFilter(WORD i_wDevice_id, BYTE i_byCANPort, BYTE i_byMode, DWORD i_dwMask, DWORD i_dwArbitration);
_EXP_ICPDAS_CANHS int __stdcall CANHS_SetCANHWSendMsg(WORD i_wDevice_id, BYTE i_byCANPort, BYTE i_byMode, DWORD i_dwID, BYTE i_byRTR, BYTE i_byDlen, BYTE *i_byData, DWORD i_dwTimer, DWORD i_dwCounter);
_EXP_ICPDAS_CANHS int __stdcall CANHS_SetCANHWSendMode(WORD i_wDevice_id, BYTE i_byCANPort, BYTE i_byMode);
_EXP_ICPDAS_CANHS int __stdcall CANHS_SetCANWhiteListMode(WORD i_wDevice_id, BYTE i_byCANPort, BYTE i_byMode);
_EXP_ICPDAS_CANHS int __stdcall CANHS_SetCANBlackListMode(WORD i_wDevice_id, BYTE i_byCANPort, BYTE i_byMode);
_EXP_ICPDAS_CANHS int __stdcall CANHS_SetCANWhiteListCANID(WORD i_wDevice_id, BYTE i_byCANPort, WORD i_wCIDNum, DWORD *i_dwCID);
_EXP_ICPDAS_CANHS int __stdcall CANHS_SetCANBlackListCANID(WORD i_wDevice_id, BYTE i_byCANPort, WORD i_wCIDNum, DWORD *i_dwCID);

_EXP_ICPDAS_CANHS int __stdcall CANHS_SetCANTxMsg(WORD i_wDevice_id, BYTE i_byCANPort, BYTE i_byMode, DWORD i_dwID, BYTE i_byRTR, BYTE i_byDlen, BYTE *i_byData);

_EXP_ICPDAS_CANHS int __stdcall CANHS_ResetModule(WORD i_wDevice_id);
_EXP_ICPDAS_CANHS int __stdcall CANHS_ResetModuleWDT(WORD i_wDevice_id);
_EXP_ICPDAS_CANHS int __stdcall CANHS_ClearCANRxBuf(WORD i_wDevice_id, BYTE i_byCANPort);
_EXP_ICPDAS_CANHS int __stdcall CANHS_ClearCANTxBuf(WORD i_wDevice_id, BYTE i_byCANPort);

// OTHERS
_EXP_ICPDAS_CANHS DWORD __stdcall CANHS_GetDllVersion(void);



#ifdef __cplusplus
}
#endif

#endif